/*************************************************************************
 * This file is part of Crosroads 1.76, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

void error (char const *fmt, ...) {
    va_list args;
    char *str;

    if (fmt && *fmt) {
	va_start (args, fmt);
	str = str_vprintf (fmt, args);
	if (!daemonized)
	    fprintf (stderr, "ERROR: %s\n", str);
	else
	    writelog (LOG_ERR, "ERROR: %s", str);
	free (str);
    }
    exit (1);
}
