/*************************************************************************
 * This file is part of Crosroads 1.76, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

HttpConnectionType http_header_connectiontype (HttpHeader *h) {
    unsigned char const *val;

    if (! (val = http_header_val (h, "proxy-connection")) )
	val = http_header_val (h, "connection");

    if (!val) {
	msg ("Service %s: Cannot determine connection type, "
	     "no such header", activeservice->name);
	return (con_unknown);
    }
    if (strcasestr ((char const *)val, "close")) {
	msg ("Service %s: Connection-Type is CLOSE",
	     activeservice->name);
	return (con_close);
    } else if (strcasestr ((char const *)val, "keep-alive")) {
	msg ("Service %s: Connection-Type is KEEP-ALIVE",
	     activeservice->name);
	return (con_keepalive);
    }
    warning ("Service %s: Unsupported Connection-Type '%s'",
	      activeservice->name, val);
    return (con_unknown);
}
