/*************************************************************************
 * This file is part of Crosroads 1.76, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

int ipf_allowed () {
    int i;

    /* Always allow a connection when we ddon't have an allow list. */
    if (! activeservice->allowchain) {
	msg ("Service %s: No allow chain (allowing client)",
	     activeservice->name);
	return (1);
    }

    /* Try all in the chain. */
    for (i = 0; i < activeservice->nallowchain; i++) {
	msg ("Service %s: Testing allow rule %d", activeservice->name, i);
	if (ipf_match (activeservice->allowchain[i])) {
	    msg ("Service %s: Allowing client (rule %d)",
		 activeservice->name, i);
	    return (1);
	}
    }

    /* Allow chain doesn't match */
    msg ("Service %s: Not allowing client due to non-match of allow chain",
	 activeservice->name);
    return (0);
}
