/*************************************************************************
 * This file is part of Crosroads 1.76, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

int ipf_denied () {
    int i;
    
    /* Never deny a connection when we don't have a deny list. */
    if (! activeservice->denychain) {
	msg ("Service %s: No deny chain (not denying client)",
	     activeservice->name);
	return (0);
    }
    
    /* Try all in the chain. */
    for (i = 0; i < activeservice->ndenychain; i++) {
	msg ("Service %s: Testing deny rule %d", activeservice->name, i);
	if (ipf_match (activeservice->denychain[i])) {
	    msg ("Service %s: Denying client (rule %d)",
		 activeservice->name, i);
	    return (1);
	}
    }
    
    /* Deny chain doesn't match */
    msg ("Service %s: Not denying client, no deny rule matches",
	 activeservice->name);
    return (0);
}
