/*************************************************************************
 * This file is part of Crosroads 1.76, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

unsigned char *net_buffer (CopyDirection dir, unsigned *sz) {
    if (dir == dir_server_to_client) {
	if (srbufmax) {
	    *sz = srbufmax - srbufpos;
	    msg ("Service %s: %d bytes still in server buffer",
		 activeservice->name, *sz);
	    srbufmax = 0;
	    return (srbuf + srbufpos);
	} else {
	    msg ("Service %s: server buffer is empty",
		 activeservice->name);
	    return (0);
	}
    } else {
	if (clbufmax) {
	    *sz = clbufmax - clbufpos;
	    msg ("Service %s: %d bytes still in client buffer",
		 activeservice->name, *sz);
	    clbufmax = 0;
	    return (clbuf + clbufpos);
	} else {
	    msg ("Service %s: client buffer is empty",
		 activeservice->name);
	    return (0);
	}
    }
}
