/*************************************************************************
 * This file is part of Crosroads 1.76, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

/*  A Bison parser, made from parser.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	IDENTIFIER	257
#define	NUMBER	258
#define	STRING	259
#define	SERVICE	260
#define	PORT	261
#define	VERBOSITY	262
#define	MAXCONNECTIONS	263
#define	TYPE	264
#define	ANY	265
#define	HTTP	266
#define	BACKEND	267
#define	SERVER	268
#define	BINDTO	269
#define	CONNECTIONTIMEOUT	270
#define	ON	271
#define	OFF	272
#define	DISPATCHMODE	273
#define	ROUNDROBIN	274
#define	RANDOM	275
#define	BYDURATION	276
#define	BYSIZE	277
#define	BYCONNECTIONS	278
#define	BYORDER	279
#define	BYCLIENTIP	280
#define	OVER	281
#define	DECAY	282
#define	REVIVINGINTERVAL	283
#define	CHECKINTERVAL	284
#define	RETRIES	285
#define	SHMKEY	286
#define	WEIGHT	287
#define	ONSTART	288
#define	ONFAIL	289
#define	BACKLOG	290
#define	THROUGHPUTLOG	291
#define	TRAFFICLOG	292
#define	HTTPTIMINGLOG	293
#define	STICKYCOOKIE	294
#define	ADDCLIENTHEADER	295
#define	SETCLIENTHEADER	296
#define	APPENDCLIENTHEADER	297
#define	ADDSERVERHEADER	298
#define	SETSERVERHEADER	299
#define	APPENDSERVERHEADER	300
#define	ALLOWFROM	301
#define	DENYFROM	302
#define	ALLOWFILE	303
#define	DENYFILE	304
#define	EXTERNALHANDLER	305
#define	USERACCOUNT	306
#define	ONEND	307
#define	HEADERINSPECTION	308
#define	DEEP	309
#define	SHALLOW	310
#define	STATE	311
#define	AVAILABLE	312
#define	UNAVAILABLE	313
#define	DOWN	314
#define	OPTIONS	315
#define	LOGACTIVITY	316
#define	TCPBUFFERSIZE	317
#define	DNSCACHETTL	318
#define	LOGFACILITY	319
#define	SHMPERMISSIONS	320
#define	SLOPPYPORTBIND	321
#define	LEAVEPROCESSTITLE	322

#line 4 "parser.y"

/* Prologue */
#include "../crossroads.h"

#define YYSTYPE Confsets

/* Static parser vars */
static int i;				/* Loop counter */
static Backend cur_backend;		/* Storage for a handled backend */
static Service cur_service;		/* Storage for a handled service */

/* Parser debugging related */
static void pmsg (char const *fmt, ...) {
    va_list args;

    if (parser_debug) {
	printf ("PARSER: ");
	va_start (args, fmt);
	vprintf (fmt, args);
    }
}

/* Conversion of yytext for symbol table */
#define SYMBOL (symtab_lookup((yytext)))

/* Error handler for yyparse() */
static int yyerror (char *msg) {
    char *sym;

    if (! yytext || ! *yytext)
	sym = "<end of file>";
    else if (isspace (*yytext))
	sym = "<white space>";
    else if (isprint (*yytext))
	sym = yytext;
    else
	sym = "<nonprintable>";
    
    error ("Parse error at %s, line %d, '%s': %s",
	   parser_filename(), yylineno + 1,
	   sym, yyerrmsg);
}

/* Store an encountered string */
static char *laststr;
static void setlaststr (char const *what) {
    free (laststr);
    laststr = xstrdup (what);
}

/* Store an encountered number */
static int lastnr;
static void setlastnr (char const *what) {
    if (what && *what && *what == '0')
	lastnr = strtol (what, 0, 8);
    else
	lastnr = atoi (what);
}

/* Store an encountered 'over' number */
static int lastovernr;
static void setlastovernr (char const *what) {
    if (what && *what && *what == '0')
	lastovernr = strtol (what, 0, 8);
    else
	lastovernr = atoi(what);
}

/* Store an encountered 'externalhandler' */
static char *lastext;
static void setlastext (char const *what) {
    free (lastext);
    lastext = xstrdup (what);
}

/* Get the server part from HOSTNAME:PORT in allocated memory */
static char *serverpart (char const *what) {
    char *ret = xstrdup (what);
    char *cp;

    if ( (cp = strchr (ret, ':')) )
	*cp = 0;
    return (ret);
}

/* Get the port part from HOSTNAME:PORT */
static int portpart (char const *what) {
    char *cp;

    if ( (cp = strchr (what, ':')) )
	return (atoi (cp + 1));
    return (0);
}

/* Add a list of IP filters to the allowlist or the denylist */
static void add_any (char *what, int chain) {
    char *item, *last = (char*) add_any;
    int result;

    for (item = strtok_r (what, " ", &last);
	 item;
	 item = strtok_r (0, " ", &last)) {
	if (chain)
	    result = ipf_add_allow (&cur_service, item);
	else
	    result = ipf_add_deny  (&cur_service, item);
	if (result)
	    error ("Bad IP filter specifier '%s' at line %d",
		   item, yylineno + 1);
    }
}
static void add_allowfrom (char *what) {
    add_any (what, 1);
}
static void add_denyfrom (char *what) {
    add_any (what, 0);
}

/* Set uid/gid for external commands. */
static void setuseraccount (char *username) {
    struct passwd *pw;

    if (! (pw = getpwnam (username)) )
	error ("Invalid username '%s' at line %d", username, yylineno + 1);
    cur_service.uid = pw->pw_uid;
    cur_service.gid = pw->pw_gid;
}

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		277
#define	YYFLAG		-32768
#define	YYNTBASE	72

#define YYTRANSLATE(x) ((unsigned)(x) <= 322 ? yytranslate[x] : 181)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    69,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    70,     2,    71,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     5,     7,     9,    14,    17,    19,    22,    24,
    26,    28,    30,    32,    34,    36,    41,    45,    49,    53,
    57,    62,    67,    73,    76,    79,    82,    84,    87,    89,
    91,    93,    95,    97,    99,   101,   103,   105,   107,   109,
   111,   113,   115,   117,   119,   121,   123,   127,   131,   134,
   137,   140,   145,   147,   149,   154,   156,   158,   159,   162,
   165,   167,   170,   172,   174,   176,   178,   180,   182,   184,
   186,   190,   193,   198,   203,   205,   206,   209,   213,   217,
   221,   225,   229,   232,   234,   236,   240,   243,   245,   247,
   251,   255,   259,   263,   266,   272,   275,   278,   280,   283,
   285,   287,   289,   291,   293,   295,   297,   299,   301,   303,
   305,   307,   309,   311,   313,   315,   317,   319,   321,   323,
   325,   330,   334,   338,   340,   344,   348,   351,   353,   355,
   357,   361,   365,   369,   373,   377,   381,   384,   387,   391,
   394,   398,   402,   406,   410,   414,   418,   421,   422,   423,
   424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
   434,   435,   436,   437,   438,   439,   440,   441,   444,   447,
   448,   449
};

static const short yyrhs[] = {    72,
    73,     0,    73,     0,    85,     0,    74,     0,    61,   176,
    75,   177,     0,    75,    76,     0,    76,     0,   180,    77,
     0,    78,     0,    79,     0,    80,     0,    81,     0,    82,
     0,    83,     0,    84,     0,    62,   164,    97,    95,     0,
    63,    94,    95,     0,    64,    94,    95,     0,    65,    94,
    95,     0,    66,    94,    95,     0,    67,   164,    97,    95,
     0,    68,   164,    97,    95,     0,    86,    87,   176,    88,
   177,     0,   160,     6,     0,   168,     3,     0,    88,    89,
     0,    89,     0,   162,    90,     0,    91,     0,    92,     0,
    96,     0,    98,     0,   107,     0,   108,     0,   111,     0,
   112,     0,   113,     0,   114,     0,   115,     0,   118,     0,
   121,     0,   123,     0,   122,     0,   124,     0,   105,     0,
   126,     0,     7,    94,    95,     0,    15,    93,    95,     0,
   170,     5,     0,   158,     4,     0,   163,    69,     0,     8,
   164,    97,    95,     0,    17,     0,    18,     0,    19,   103,
    99,    95,     0,   100,     0,   102,     0,     0,    27,   101,
     0,   158,     4,     0,   145,     0,   165,   104,     0,    20,
     0,    21,     0,    22,     0,    23,     0,    25,     0,    24,
     0,    51,     0,    26,     0,    52,   106,    95,     0,   174,
     5,     0,    29,    94,   109,    95,     0,    30,    94,   109,
    95,     0,   110,     0,     0,    51,   145,     0,    36,    94,
    95,     0,    32,    94,    95,     0,    16,    94,    95,     0,
     9,    94,    95,     0,    10,   116,    95,     0,   171,   117,
     0,    11,     0,    12,     0,    54,   119,    95,     0,   172,
   120,     0,    55,     0,    56,     0,    47,   125,    95,     0,
    48,   125,    95,     0,    49,   146,    95,     0,    50,   146,
    95,     0,   173,     5,     0,    13,   127,   176,   128,   177,
     0,   169,     3,     0,   128,   129,     0,   129,     0,   161,
   130,     0,   131,     0,    91,     0,    96,     0,   139,     0,
   141,     0,   140,     0,   142,     0,   143,     0,   144,     0,
   132,     0,   133,     0,   114,     0,   147,     0,   149,     0,
   150,     0,   151,     0,   152,     0,   153,     0,   154,     0,
   135,     0,   136,     0,    14,   159,   134,    95,     0,    33,
    94,    95,     0,    28,    94,    95,     0,     5,     0,    31,
    94,    95,     0,    57,   137,    95,     0,   175,   138,     0,
    58,     0,    59,     0,    60,     0,    34,   145,    95,     0,
    35,   145,    95,     0,    53,   145,    95,     0,    38,   146,
    95,     0,    37,   146,    95,     0,    39,   146,    95,     0,
   166,     5,     0,   167,     5,     0,    40,   148,    95,     0,
   157,     5,     0,    41,   155,    95,     0,    42,   155,    95,
     0,    43,   155,    95,     0,    44,   155,    95,     0,    45,
   155,    95,     0,    46,   155,    95,     0,   156,     5,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   178,    70,     0,   179,    71,     0,     0,     0,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   160,   163,   167,   169,   173,   180,   183,   187,   192,   194,
   196,   198,   200,   202,   204,   208,   217,   225,   233,   241,
   249,   258,   267,   291,   296,   307,   310,   314,   319,   325,
   331,   337,   347,   355,   362,   368,   374,   380,   386,   392,
   398,   404,   410,   416,   422,   429,   603,   615,   627,   636,
   643,   648,   661,   665,   671,   680,   682,   684,   690,   707,
   714,   724,   733,   737,   741,   745,   749,   753,   757,   761,
   767,   779,   788,   806,   824,   826,   832,   841,   853,   865,
   877,   889,   901,   906,   910,   916,   928,   933,   937,   943,
   955,   967,   979,   991,  1000,  1010,  1022,  1030,  1036,  1043,
  1048,  1053,  1058,  1063,  1068,  1073,  1078,  1083,  1088,  1093,
  1098,  1103,  1108,  1113,  1118,  1123,  1128,  1133,  1138,  1143,
  1150,  1163,  1175,  1187,  1193,  1205,  1217,  1222,  1226,  1230,
  1236,  1248,  1260,  1272,  1284,  1296,  1308,  1317,  1326,  1338,
  1347,  1359,  1371,  1383,  1395,  1407,  1419,  1428,  1433,  1438,
  1443,  1448,  1453,  1458,  1463,  1468,  1473,  1478,  1483,  1488,
  1493,  1498,  1503,  1508,  1513,  1518,  1523,  1528,  1533,  1538,
  1542,  1546
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","IDENTIFIER",
"NUMBER","STRING","SERVICE","PORT","VERBOSITY","MAXCONNECTIONS","TYPE","ANY",
"HTTP","BACKEND","SERVER","BINDTO","CONNECTIONTIMEOUT","ON","OFF","DISPATCHMODE",
"ROUNDROBIN","RANDOM","BYDURATION","BYSIZE","BYCONNECTIONS","BYORDER","BYCLIENTIP",
"OVER","DECAY","REVIVINGINTERVAL","CHECKINTERVAL","RETRIES","SHMKEY","WEIGHT",
"ONSTART","ONFAIL","BACKLOG","THROUGHPUTLOG","TRAFFICLOG","HTTPTIMINGLOG","STICKYCOOKIE",
"ADDCLIENTHEADER","SETCLIENTHEADER","APPENDCLIENTHEADER","ADDSERVERHEADER","SETSERVERHEADER",
"APPENDSERVERHEADER","ALLOWFROM","DENYFROM","ALLOWFILE","DENYFILE","EXTERNALHANDLER",
"USERACCOUNT","ONEND","HEADERINSPECTION","DEEP","SHALLOW","STATE","AVAILABLE",
"UNAVAILABLE","DOWN","OPTIONS","LOGACTIVITY","TCPBUFFERSIZE","DNSCACHETTL","LOGFACILITY",
"SHMPERMISSIONS","SLOPPYPORTBIND","LEAVEPROCESSTITLE","';'","'{'","'}'","input",
"element","option_element","option_statements","option_statement","optstat",
"logactivity_statement","tcpbuffersize_statement","dnscachettl_statement","logfacility_statement",
"shmpermissions_statement","sloppyportbind_statement","leaveprocesstitle_statement",
"service_element","service","servicename","servicestatements","servicestatement",
"servicebody","portstatement","bindstatement","ipaddress","number","semicol",
"verbositystatement","onoff","dispatchmodestatement","dispatchtail","dispatchover",
"overnumber","dispatchext","dispatchmethod","dispatchmethodspec","useraccountstatement",
"useraccount","revivingintervalstatement","checkintervalstatement","opt_externalhandler",
"externalhandler","backlogstatement","shmkeystatement","connectiontimeoutstatement",
"maxconnectionsstatement","typestatement","typespec","typespecifier","inspectionstatement",
"shallowdeepspec","shallowdeepspecifier","allowfromstatement","denyfromstatement",
"allowfilestatement","denyfilestatement","ipfilters","backendblock","backendname",
"backenddefinitions","backenddefinition","backendstatement","serverstatement",
"weightstatement","decaystatement","serveraddress","retriesstatement","initialstatestatement",
"statedef","somestate","onstartstatement","onfailstatement","onendstatement",
"dumptrafficstatement","throughputstatement","httptiminglogstatement","commandline",
"filename","stickycookiestatement","cookiespecifier","addclientheaderstatement",
"setclientheaderstatement","appendclientheaderstatement","addserverheaderstatement",
"setserverheaderstatement","appendserverheaderstatement","headerstring","headerstring_expected",
"cookie_expected","number_expected","serveraddress_expected","service_expected",
"backendstatement_expected","servicebody_expected","semicol_expected","onoff_expected",
"dispatchmethod_expected","commandline_expected","filename_expected","servicename_expected",
"backendname_expected","ipaddress_expected","type_expected","shallowdeep_expected",
"ipfilters_expected","useraccount_expected","statedef_expected","openbrace",
"closebrace","openbrace_expected","closebrace_expected","option_statement_expected", NULL
};
#endif

static const short yyr1[] = {     0,
    72,    72,    73,    73,    74,    75,    75,    76,    77,    77,
    77,    77,    77,    77,    77,    78,    79,    80,    81,    82,
    83,    84,    85,    86,    87,    88,    88,    89,    90,    90,
    90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
    90,    90,    90,    90,    90,    90,    91,    92,    93,    94,
    95,    96,    97,    97,    98,    99,    99,    99,   100,   101,
   102,   103,   104,   104,   104,   104,   104,   104,   104,   104,
   105,   106,   107,   108,   109,   109,   110,   111,   112,   113,
   114,   115,   116,   117,   117,   118,   119,   120,   120,   121,
   122,   123,   124,   125,   126,   127,   128,   128,   129,   130,
   130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
   130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   138,   138,
   139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
   149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
   159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
   169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
   179,   180
};

static const short yyr2[] = {     0,
     2,     1,     1,     1,     4,     2,     1,     2,     1,     1,
     1,     1,     1,     1,     1,     4,     3,     3,     3,     3,
     4,     4,     5,     2,     2,     2,     1,     2,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     3,     3,     2,     2,
     2,     4,     1,     1,     4,     1,     1,     0,     2,     2,
     1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
     3,     2,     4,     4,     1,     0,     2,     3,     3,     3,
     3,     3,     2,     1,     1,     3,     2,     1,     1,     3,
     3,     3,     3,     2,     5,     2,     2,     1,     2,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     4,     3,     3,     1,     3,     3,     2,     1,     1,     1,
     3,     3,     3,     3,     3,     3,     2,     2,     3,     2,
     3,     3,     3,     3,     3,     3,     2,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     2,     2,     0,
     0,     0
};

static const short yydefact[] = {   152,
   170,   152,     2,     4,     3,   160,     0,   172,     0,     1,
   170,     0,    24,   172,     7,     0,   168,   154,    25,     6,
     5,     0,   156,   150,   150,   150,   150,   156,   156,     8,
     9,    10,    11,    12,    13,    14,    15,   154,    27,     0,
   169,     0,   155,     0,   155,   155,   155,     0,     0,    26,
    23,   150,   156,   150,   163,   161,   162,   150,   157,   150,
   150,   150,   150,   165,   165,   159,   159,   166,   164,    28,
    29,    30,    31,    32,    45,    33,    34,    35,    36,    37,
    38,    39,    40,    41,    43,    42,    44,    46,    53,    54,
   155,    17,     0,    50,    18,    19,    20,   155,   155,   155,
     0,   155,   155,     0,   170,     0,   155,     0,   155,    58,
     0,    76,    76,   155,   155,   155,     0,   155,   155,     0,
   155,   155,     0,   155,     0,    16,    51,    21,    22,    47,
   155,    81,    82,    84,    85,    83,   153,    96,    48,    49,
    80,   150,   155,    56,    57,    61,     0,    63,    64,    65,
    66,    68,    67,    70,    69,    62,   158,   155,    75,   155,
    79,    78,    90,    94,    91,    92,   138,    93,    71,    72,
    86,    88,    89,    87,    52,   153,    98,     0,    59,     0,
    55,   137,    77,    73,    74,    97,    95,   151,   150,   150,
   150,   158,   158,   159,   159,   159,   149,   148,   148,   148,
   148,   148,   148,   158,   167,   101,   102,   111,    99,   100,
   109,   110,   119,   120,   103,   105,   104,   106,   107,   108,
   112,   113,   114,   115,   116,   117,   118,    60,     0,   155,
   155,   155,   155,   155,   155,   155,   155,   155,     0,   155,
     0,   155,   155,   155,   155,   155,   155,   155,     0,   124,
   155,   123,   125,   122,   131,   132,   135,   134,   136,   139,
   140,   141,   147,   142,   143,   144,   145,   146,   133,   126,
   128,   129,   130,   127,   121,     0,     0
};

static const short yydefgoto[] = {     2,
     3,     4,    14,    15,    30,    31,    32,    33,    34,    35,
    36,    37,     5,     6,    11,    38,    39,    70,    71,    72,
   107,    43,    92,    73,    91,    74,   143,   144,   179,   145,
   110,   156,    75,   122,    76,    77,   158,   159,    78,    79,
    80,    81,    82,   103,   136,    83,   124,   174,    84,    85,
    86,    87,   116,    88,   105,   176,   177,   209,   210,   211,
   212,   251,   213,   214,   248,   274,   215,   216,   217,   218,
   219,   220,   146,   119,   221,   238,   222,   223,   224,   225,
   226,   227,   240,   241,   239,    44,   229,     7,   178,    40,
    93,    42,   111,   147,   120,    12,   106,   108,   104,   125,
   117,   123,   249,     8,    21,     9,    22,    16
};

static const short yypact[] = {   -51,
-32768,    11,-32768,-32768,-32768,-32768,     8,-32768,   -39,-32768,
-32768,    48,-32768,   -19,-32768,    41,-32768,-32768,-32768,-32768,
-32768,   -10,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -19,-32768,   200,
-32768,    25,-32768,    59,-32768,-32768,-32768,    25,    25,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    -2,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
    25,-32768,-32768,    38,-32768,    63,-32768,    70,-32768,    10,
    -4,    17,    17,-32768,-32768,-32768,    73,-32768,-32768,    75,
-32768,-32768,    76,-32768,     4,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    77,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   -19,-32768,    86,-32768,    79,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    80,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    82,-32768,
    83,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -25,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    84,-32768
};

static const short yypgoto[] = {-32768,
    87,-32768,-32768,    78,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    52,-32768,   -87,-32768,
-32768,   -22,   -45,   -82,   -36,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   -16,-32768,-32768,-32768,
-32768,   -79,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    36,-32768,-32768,-32768,   -66,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,  -148,   -60,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,  -174,-32768,-32768,   -31,-32768,-32768,-32768,-32768,
-32768,    -5,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    -3,   -32,-32768,-32768,-32768
};


#define	YYLAST		254


static const short yytable[] = {    95,
    96,    97,    45,    46,    47,    51,   121,    18,   183,     1,
   276,    98,    99,    13,  -158,   148,   149,   150,   151,   152,
   153,   154,    48,    49,   242,   243,   244,   245,   246,   100,
    17,   102,   271,   272,   273,   109,   142,   112,   113,   114,
   115,    89,    90,   233,   234,   126,   155,   101,   134,   135,
    19,  -171,   128,   129,   130,   247,   132,   133,   172,   173,
    41,   139,    94,   141,   131,   138,   127,   157,   161,   162,
   163,     1,   165,   166,   140,   168,   169,   164,   171,   167,
   170,   182,   228,   277,   250,   175,   261,   263,    10,    50,
   206,    20,    52,    53,    54,   207,   160,   181,   208,   188,
   118,   137,    23,    24,    25,    26,    27,    28,    29,   186,
   180,     0,   184,   189,   185,     0,   190,     0,   191,   192,
   193,     0,   194,   195,   196,   197,   198,   199,   200,   201,
   202,   203,     0,   235,   236,   237,     0,     0,   204,     0,
     0,     0,   205,   187,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   230,   231,   232,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   252,   253,   254,   255,   256,   257,
   258,   259,   260,     0,   262,     0,   264,   265,   266,   267,
   268,   269,   270,     0,     0,   275,    52,    53,    54,    55,
     0,     0,    56,     0,    57,    58,     0,     0,    59,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    60,    61,
     0,    62,     0,     0,     0,    63,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    64,    65,    66,    67,
     0,    68,     0,    69
};

static const short yycheck[] = {    45,
    46,    47,    25,    26,    27,    38,    67,    11,   157,    61,
     0,    48,    49,     6,     5,    20,    21,    22,    23,    24,
    25,    26,    28,    29,   199,   200,   201,   202,   203,    52,
    70,    54,    58,    59,    60,    58,    27,    60,    61,    62,
    63,    17,    18,   192,   193,    91,    51,    53,    11,    12,
     3,    71,    98,    99,   100,   204,   102,   103,    55,    56,
    71,   107,     4,   109,   101,     3,    69,    51,   114,   115,
   116,    61,   118,   119,     5,   121,   122,     5,   124,     5,
     5,     5,     4,     0,     5,   131,     5,     5,     2,    38,
   178,    14,     7,     8,     9,   178,   113,   143,   178,    14,
    65,   105,    62,    63,    64,    65,    66,    67,    68,   176,
   142,    -1,   158,    28,   160,    -1,    31,    -1,    33,    34,
    35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
    45,    46,    -1,   194,   195,   196,    -1,    -1,    53,    -1,
    -1,    -1,    57,   176,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   189,   190,   191,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,   235,
   236,   237,   238,    -1,   240,    -1,   242,   243,   244,   245,
   246,   247,   248,    -1,    -1,   251,     7,     8,     9,    10,
    -1,    -1,    13,    -1,    15,    16,    -1,    -1,    19,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,    30,
    -1,    32,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    47,    48,    49,    50,
    -1,    52,    -1,    54
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 16:
#line 212 "parser.y"
{
	    opt.log_activity = lastnr;
	;
    break;}
case 17:
#line 220 "parser.y"
{
	    opt.tcp_bufsz = lastnr;
	;
    break;}
case 18:
#line 228 "parser.y"
{
	    opt.dns_cachettl = lastnr;
	;
    break;}
case 19:
#line 236 "parser.y"
{
	    opt.log_facility = lastnr;
	;
    break;}
case 20:
#line 244 "parser.y"
{
	    opt.shmperm = lastnr;
	;
    break;}
case 21:
#line 253 "parser.y"
{
	    opt.sloppyportbind = lastnr;
	;
    break;}
case 22:
#line 262 "parser.y"
{
	    opt.leave_proctitle = lastnr;
	;
    break;}
case 23:
#line 272 "parser.y"
{
	    /* Check integrity, supply defaults */
	    check_service (cur_service);
	    
	    if (!cur_service.shmkey)
		cur_service.shmkey = (unsigned) hashpjw (cur_service.name);
	    msg ("Service %s: shared memory key set to 0x%8.8x",
		 cur_service.name, cur_service.shmkey);

	    if (!cur_service.check_cmd)
		cur_service.check_cmd = xstrdup ("");
	    
	    /* Add to the list, reset cur_service for next run */
	    service = xrealloc (service, ++nservice * sizeof(Service));
	    service[nservice - 1] = cur_service;
	    memset (&cur_service, 0, sizeof(Service));
	;
    break;}
case 25:
#line 298 "parser.y"
{
	    pmsg ("service [%s]\n", SYMBOL);
	    for (i = 0; i < nservice; i++)
		if (!strcmp (service[i].name, SYMBOL))
		    error ("Duplicate definition of service '%s'", SYMBOL);
	    cur_service.name = xstrdup(SYMBOL);
	;
    break;}
case 29:
#line 320 "parser.y"
{
	    pmsg ("sevice port [%d]\n", yyvsp[0].set[0].v.ival);
	    cur_service.port = yyvsp[0].set[0].v.ival;
	    free (yyvsp[0].set);
	;
    break;}
case 30:
#line 326 "parser.y"
{
	    pmsg ("service binding [%s]\n", yyvsp[0].set[0].v.sval);
	    cur_service.bind = yyvsp[0].set[0].v.sval;
	    free (yyvsp[0].set);
	;
    break;}
case 31:
#line 332 "parser.y"
{
	    pmsg ("service verbosity [%d]\n", yyvsp[0].set[0].v.ival);
	    cur_service.verbosity = yyvsp[0].set[0].v.ival;
	    free (yyvsp[0].set);
	;
    break;}
case 32:
#line 338 "parser.y"
{
	    pmsg ("service dispatch mode [%d]\n", yyvsp[0].set[0].v.ival);
	    pmsg ("service dispatch over [%d]\n", lastovernr);
	    pmsg ("service dispatch exthandler [%s]\n", lastext);
	    cur_service.dispatchtype = yyvsp[0].set[0].v.ival;
	    cur_service.dispatchover = lastovernr;
	    cur_service.dispatchext  = xstrdup(lastext);
	    free (yyvsp[0].set);
	;
    break;}
case 33:
#line 348 "parser.y"
{
	    pmsg ("service revival interval [%d]\n", yyvsp[0].set[0].v.ival);
	    pmsg ("service revival cmd [%s]\n", yyvsp[0].set[1].v.sval);
	    cur_service.rev_interval = yyvsp[0].set[0].v.ival;
	    cur_service.check_cmd = yyvsp[0].set[1].v.sval;
	    free (yyvsp[0].set);
	;
    break;}
case 34:
#line 356 "parser.y"
{
	    pmsg ("service check interval [%d]\n", yyvsp[0].set[0].v.ival);
	    pmsg ("service check cmd [%s]\n", yyvsp[0].set[1].v.sval);
	    cur_service.check_interval = yyvsp[0].set[0].v.ival;
	    cur_service.check_cmd = yyvsp[0].set[1].v.sval;
	;
    break;}
case 35:
#line 363 "parser.y"
{
	    pmsg ("service backlog [%d]\n", yyvsp[0].set[0].v.ival);
	    cur_service.backlog = yyvsp[0].set[0].v.ival;
	    free (yyvsp[0].set);
	;
    break;}
case 36:
#line 369 "parser.y"
{
	    pmsg ("service shmkey [%d]\n", yyvsp[0].set[0].v.ival);
	    cur_service.shmkey = yyvsp[0].set[0].v.ival;
	    free (yyvsp[0].set);
	;
    break;}
case 37:
#line 375 "parser.y"
{
	    pmsg ("connection timout [%d]\n", yyvsp[0].set[0].v.ival);
	    cur_service.connectiontimeout = yyvsp[0].set[0].v.ival;
	    free (yyvsp[0].set);
	;
    break;}
case 38:
#line 381 "parser.y"
{
	    pmsg ("max clients in service [%d]\n", yyvsp[0].set[0].v.ival);
	    cur_service.maxconnections = yyvsp[0].set[0].v.ival;
	    free (yyvsp[0].set);
	;
    break;}
case 39:
#line 387 "parser.y"
{
	    pmsg ("service type [%d]\n", yyvsp[0].set[0].v.ival);
	    cur_service.type = yyvsp[0].set[0].v.ival;
	    free (yyvsp[0].set);
	;
    break;}
case 40:
#line 393 "parser.y"
{
	    pmsg ("service header inspection [%d]\n", yyvsp[0].set[0].v.ival);
	    cur_service.inspection = yyvsp[0].set[0].v.ival;
	    free (yyvsp[0].set);
	;
    break;}
case 41:
#line 399 "parser.y"
{
	    pmsg ("allow from [%s]\n", yyvsp[0].set[0].v.sval);
	    add_allowfrom (yyvsp[0].set[0].v.sval);
	    free (yyvsp[0].set);
	;
    break;}
case 42:
#line 405 "parser.y"
{
	    pmsg ("allow file [%s]\n", yyvsp[0].set[0].v.sval);
	    cur_service.allowfile = yyvsp[0].set[0].v.sval;
	    free (yyvsp[0].set);
	;
    break;}
case 43:
#line 411 "parser.y"
{
	    pmsg ("deny from [%s]\n", yyvsp[0].set[0].v.sval);
	    add_denyfrom (yyvsp[0].set[0].v.sval);
	    free (yyvsp[0].set);
	;
    break;}
case 44:
#line 417 "parser.y"
{
	    pmsg ("deny file [%s]\n", yyvsp[0].set[0].v.sval);
	    cur_service.denyfile = yyvsp[0].set[0].v.sval;
	    free (yyvsp[0].set);
	;
    break;}
case 45:
#line 423 "parser.y"
{
	    pmsg ("user account [%s]\n", yyvsp[0].set[0].v.sval);
	    setuseraccount (yyvsp[0].set[0].v.sval);
	    free (yyvsp[0].set[0].v.sval);
	    free (yyvsp[0].set);
	;
    break;}
case 46:
#line 430 "parser.y"
{
	    pmsg ("converting backend statements, count is [%d]\n", yyvsp[0].n);
	    for (i = 0; i < yyvsp[0].n; i++)
		switch (yyvsp[0].set[i].cf) {
		case cf_portspec:
		    pmsg ("backend port [%d]\n", yyvsp[0].set[i].v.ival);
		    cur_backend.initial_port = yyvsp[0].set[i].v.ival;
		    break;
		case cf_serverspec:
		    pmsg ("backend server [%s]\n", yyvsp[0].set[i].v.sval);
		    cur_backend.initial_server = serverpart (yyvsp[0].set[i].v.sval);
		    cur_backend.initial_port   = portpart (yyvsp[0].set[i].v.sval);
		    free (yyvsp[0].set[i].v.sval);
		    break;
		case cf_verbosityspec:
		    pmsg ("backend verbosity [%d]\n", yyvsp[0].set[i].v.ival);
		    cur_backend.verbosity = yyvsp[0].set[i].v.ival;
		    break;
		case cf_onstartspec:
		    pmsg ("backend onstart [%s]\n", yyvsp[0].set[i].v.sval);
		    cur_backend.onstart = yyvsp[0].set[i].v.sval;
		    break;
		case cf_onfailspec:
		    pmsg ("backend onfail [%s]\n", yyvsp[0].set[i].v.sval);
		    cur_backend.onfail = yyvsp[0].set[i].v.sval;
		    break;
		case cf_onendspec:
		    pmsg ("backend onend [%s]\n", yyvsp[0].set[i].v.sval);
		    cur_backend.onend = yyvsp[0].set[i].v.sval;
		    break;
		case cf_dumpspec:
		    pmsg ("backend trafficlog [%s]\n", yyvsp[0].set[i].v.sval);
		    cur_backend.dumpfile = yyvsp[0].set[i].v.sval;
		    break;
		case cf_thruspec:
		    pmsg ("backend throughputlog [%s]\n", yyvsp[0].set[i].v.sval);
		    cur_backend.thruputfile = yyvsp[0].set[i].v.sval;
		    break;
		case cf_httptimingspec:
		    if (cur_service.type != type_http)
			error ("'httptiminglog' only allowed in 'type http' "
			       "service definitions");
		    pmsg ("backend http timing log [%s]\n", yyvsp[0].set[i].v.sval);
		    cur_backend.timinglog = yyvsp[0].set[i].v.sval;
		    break;
		case cf_weightspec:
		    pmsg ("backend weight [%d]\n", yyvsp[0].set[i].v.ival);
		    cur_backend.weight = yyvsp[0].set[i].v.ival;
		    break;
		case cf_decayspec:
		    pmsg ("backend decay [%d]\n", yyvsp[0].set[i].v.ival);
		    if (yyvsp[0].set[i].v.ival >= 100)
			error ("Decay specifier %d must be a percentage, "
			       "never more than 99",
			       yyvsp[0].set[i].v.ival);
		    cur_backend.decay = yyvsp[0].set[i].v.ival;
		    break;
		case cf_maxconnectionsspec:
		    pmsg ("backend max clients [%d]\n", yyvsp[0].set[i].v.ival);
		    cur_backend.maxconnections = yyvsp[0].set[i].v.ival;
		    break;
		case cf_stickycookiespec:
		    pmsg ("backend sticky cookie [%s]\n",
			  yyvsp[0].set[i].v.sval);
		    cur_backend.stickycookie = yyvsp[0].set[i].v.sval;
		    break;
		case cf_addclientheaderspec:
		    pmsg ("client header to add [%s]\n",
			  yyvsp[0].set[i].v.sval);
		    cur_backend.addclientheader =
			xrealloc (cur_backend.addclientheader,
				  (cur_backend.naddclientheader + 1) *
				  sizeof(char*));
		    cur_backend.addclientheader
			[cur_backend.naddclientheader++] =
			    yyvsp[0].set[i].v.sval;
		    break;
		case cf_setclientheaderspec:
		    pmsg ("client header to set [%s]\n",
			  yyvsp[0].set[i].v.sval);
		    cur_backend.setclientheader =
			xrealloc (cur_backend.setclientheader,
				  (cur_backend.nsetclientheader + 1) *
				  sizeof(char*));
		    cur_backend.setclientheader
			[cur_backend.nsetclientheader++] =
			    yyvsp[0].set[i].v.sval;
		    break;
		case cf_appendclientheaderspec:
		    pmsg ("client header to append [%s]\n",
			  yyvsp[0].set[i].v.sval);
		    cur_backend.appendclientheader =
			xrealloc (cur_backend.appendclientheader,
				  (cur_backend.nappendclientheader + 1) *
				  sizeof(char*));
		    cur_backend.appendclientheader
			[cur_backend.nappendclientheader++] =
			    yyvsp[0].set[i].v.sval;
		    break;
		case cf_addserverheaderspec:
		    pmsg ("server header to add [%s]\n",
			  yyvsp[0].set[i].v.sval);
		    cur_backend.addserverheader =
			xrealloc (cur_backend.addserverheader,
				  (cur_backend.naddserverheader + 1) *
				  sizeof(char*));
		    cur_backend.addserverheader
			[cur_backend.naddserverheader++] =
			    yyvsp[0].set[i].v.sval;
		    break;
		case cf_setserverheaderspec:
		    pmsg ("server header to set [%s]\n",
			  yyvsp[0].set[i].v.sval);
		    cur_backend.setserverheader =
			xrealloc (cur_backend.setserverheader,
				  (cur_backend.nsetserverheader + 1) *
				  sizeof(char*));
		    cur_backend.setserverheader
			[cur_backend.nsetserverheader++] =
			    yyvsp[0].set[i].v.sval;
		    break;
		case cf_appendserverheaderspec:
		    pmsg ("server header to append:",
			  yyvsp[0].set[i].v.sval);
		    cur_backend.appendserverheader =
			xrealloc (cur_backend.appendserverheader,
				  (cur_backend.nappendserverheader + 1) *
				  sizeof(char*));
		    cur_backend.appendserverheader
			[cur_backend.nappendserverheader++] =
			    yyvsp[0].set[i].v.sval;
		    break;
		case cf_retriesspec:
		    pmsg ("backend retries [%d]\n", yyvsp[0].set[i].v.ival);
		    cur_backend.retries = yyvsp[0].set[i].v.ival;
		    break;
		case cf_statespec:
		    pmsg ("backend initial state [%d]\n", yyvsp[0].set[i].v.ival);
		    cur_backend.initial_avail = yyvsp[0].set[i].v.ival;
		    break;
		default:
		    error ("Internal jam, unhandled type %d "
			   "in backend specification",
			   yyvsp[0].set[i].cf);
		}
	    free (yyvsp[0].set);

	    /* Verify the backend block, supply defaults,
	     * And so on.
	     */
	    if (!cur_backend.initial_port)
		error ("Service %s: back end %s lacks port",
		       cur_service.name, cur_backend.name);
	    if (cur_service.dispatchext && cur_backend.maxconnections)
		error ("Service %s: back end %s defines maxconnections, "
		       "but an external dispatcher is in effect",
		       cur_service.name, cur_backend.name);
	    if (cur_backend.weight < 1)
		cur_backend.weight = 1;
	    if (cur_backend.retries < 1)
		cur_backend.retries = 1;
	    
	    /* Add to the list. */
	    cur_service.backend = xrealloc (cur_service.backend,
					    ++cur_service.nbackend *
					    sizeof(Backend));
	    cur_service.backend[cur_service.nbackend - 1] =
		cur_backend;
	    pmsg ("this was backend definition [%d]\n", cur_service.nbackend);
	    memset (&cur_backend, 0, sizeof(cur_backend));
	;
    break;}
case 47:
#line 606 "parser.y"
{
	    pmsg ("port statement [%d]\n", lastnr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_portspec;
	    yyval.set[0].v.ival = lastnr;
	;
    break;}
case 48:
#line 618 "parser.y"
{
	    pmsg ("bindto statement [%d]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_bindspec;
	    yyval.set[0].v.sval = xstrdup(laststr);
	;
    break;}
case 49:
#line 629 "parser.y"
{
	    setlaststr (laststring);
	    free (laststring);
	    laststring = 0;
	;
    break;}
case 50:
#line 638 "parser.y"
{
	    setlastnr (SYMBOL);
	;
    break;}
case 52:
#line 652 "parser.y"
{
	    pmsg ("verbosity statement [%d]\n", lastnr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_verbosityspec;
	    yyval.set[0].v.ival = lastnr;
	;
    break;}
case 53:
#line 662 "parser.y"
{
	    lastnr = 1;
	;
    break;}
case 54:
#line 666 "parser.y"
{
	    lastnr = 0;
	;
    break;}
case 55:
#line 675 "parser.y"
{
	    yyval = yyvsp[-2];
	;
    break;}
case 58:
#line 685 "parser.y"
{
	    yyval.n = 0;
	;
    break;}
case 59:
#line 692 "parser.y"
{
	    pmsg ("dispatch mode statement [%d]\n", lastnr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_dispatchspec;
	    yyval.set[0].v.ival = lastnr;

	    if (lastovernr &&
		(lastnr != ds_bysize && lastnr != ds_byduration))
		error ("Service '%s': this dispatch mode "
		       "doesn't support 'over <connections>'",
		       cur_service.name);
	;
    break;}
case 60:
#line 709 "parser.y"
{
	    setlastovernr (SYMBOL);
	;
    break;}
case 61:
#line 715 "parser.y"
{
	    pmsg ("external handler [%s]\n", laststr);
	    if (lastnr != ds_externalhandler)
		error ("Service %s: this dispatch mode doesn't support "
		       "an external handler", cur_service.name);
	    setlastext (laststr);
	;
    break;}
case 62:
#line 726 "parser.y"
{
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].v.ival = lastnr;
	;
    break;}
case 63:
#line 734 "parser.y"
{
	    lastnr = ds_roundrobin;
	;
    break;}
case 64:
#line 738 "parser.y"
{
	    lastnr = ds_random;
	;
    break;}
case 65:
#line 742 "parser.y"
{
	    lastnr = ds_byduration;
	;
    break;}
case 66:
#line 746 "parser.y"
{
	    lastnr = ds_bysize;
	;
    break;}
case 67:
#line 750 "parser.y"
{
	    lastnr = ds_byorder;
	;
    break;}
case 68:
#line 754 "parser.y"
{
	    lastnr = ds_byconnections;
	;
    break;}
case 69:
#line 758 "parser.y"
{
	    lastnr = ds_externalhandler;
	;
    break;}
case 70:
#line 762 "parser.y"
{
	    lastnr = ds_byclientip;
	;
    break;}
case 71:
#line 770 "parser.y"
{
	    pmsg ("user account statement [%d]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_useraccountspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 72:
#line 781 "parser.y"
{
	    setlaststr (laststring);
	    free (laststring);
	    laststring = 0;
	;
    break;}
case 73:
#line 792 "parser.y"
{
	    pmsg ("reviving interval statement [%d]\n", lastnr);
	    yyval.n = 2;
	    yyval.set = xmalloc (2 * sizeof(Confset));
	    yyval.set[0].cf = cf_revivespec;
	    yyval.set[0].v.ival = lastnr;
	    if (yyvsp[-1].n) {
		pmsg ("reviving externalhandler [%s]\n", yyvsp[-1].set[0].v.sval);
		yyval.set[1].v.sval = yyvsp[-1].set[0].v.sval;
	    } else
		yyval.set[1].v.sval = 0;
	;
    break;}
case 74:
#line 810 "parser.y"
{
	    pmsg ("check interval [%d]\n", lastnr);
	    yyval.n = 2;
	    yyval.set = xmalloc (2 * sizeof(Confset));
	    yyval.set[0].cf = cf_checkspec;
	    yyval.set[0].v.ival = lastnr;
	    if (yyvsp[-1].n) {
		pmsg ("check externalhandler [%s]\n", yyvsp[-1].set[0].v.sval);
		yyval.set[1].v.sval = yyvsp[-1].set[0].v.sval;
	    } else
		yyval.set[1].v.sval = 0;
	;
    break;}
case 76:
#line 827 "parser.y"
{
	    yyval.n = 0;
	;
    break;}
case 77:
#line 834 "parser.y"
{
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 78:
#line 844 "parser.y"
{
	    pmsg ("backlog statement [%d]\n", lastnr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_backlogspec;
	    yyval.set[0].v.ival = lastnr;
	;
    break;}
case 79:
#line 856 "parser.y"
{
	    pmsg ("shmkey statement [%d]\n", lastnr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_shmkeyspec;
	    yyval.set[0].v.ival = lastnr;
	;
    break;}
case 80:
#line 868 "parser.y"
{
	    pmsg ("connection timeout statement [%d]\n", lastnr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_connectiontimeoutspec;
	    yyval.set[0].v.ival = lastnr;
	;
    break;}
case 81:
#line 880 "parser.y"
{
	    pmsg ("max clients statement (service) [%d]\n", lastnr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_maxconnectionsspec;
	    yyval.set[0].v.ival = lastnr;
	;
    break;}
case 82:
#line 892 "parser.y"
{
	    pmsg ("service type [%d]\n", lastnr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_typespec;
	    yyval.set[0].v.ival = lastnr;
	;
    break;}
case 84:
#line 907 "parser.y"
{
	    lastnr = type_any;
	;
    break;}
case 85:
#line 911 "parser.y"
{
	    lastnr = type_http;
	;
    break;}
case 86:
#line 919 "parser.y"
{
	    pmsg ("service header inspection [%d]\n", lastnr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_inspectionspec;
	    yyval.set[0].v.ival = lastnr;
	;
    break;}
case 88:
#line 934 "parser.y"
{
	    lastnr = ins_deep;
	;
    break;}
case 89:
#line 938 "parser.y"
{
	    lastnr = ins_shallow;
	;
    break;}
case 90:
#line 946 "parser.y"
{
	    pmsg ("allow from [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_allowfromspec;
	    yyval.set[0].v.sval = xstrdup(laststr);
	;
    break;}
case 91:
#line 958 "parser.y"
{
	    pmsg ("deny from [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_denyfromspec;
	    yyval.set[0].v.sval = xstrdup(laststr);
	;
    break;}
case 92:
#line 970 "parser.y"
{
	    pmsg ("allow file [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_allowfilespec;
	    yyval.set[0].v.sval = xstrdup(laststr);
	;
    break;}
case 93:
#line 982 "parser.y"
{
	    pmsg ("deny file [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_allowfilespec;
	    yyval.set[0].v.sval = xstrdup(laststr);
	;
    break;}
case 94:
#line 993 "parser.y"
{
	    setlaststr (laststring);
	    free (laststring);
	    laststring = 0;
	;
    break;}
case 95:
#line 1005 "parser.y"
{
	    yyval = yyvsp[-1];
	;
    break;}
case 96:
#line 1012 "parser.y"
{
	    pmsg ("backend name [%s]\n", SYMBOL);
	    for (i = 0; i < cur_service.nbackend; i++)
		if (!strcmp (cur_service.backend[i].name, SYMBOL))
		    error ("Service %s: back end '%s' multiply defined",
			   cur_service.name, SYMBOL);
	    cur_backend.name = xstrdup (SYMBOL);
	;
    break;}
case 97:
#line 1024 "parser.y"
{
	    yyvsp[-1].n++;
	    yyvsp[-1].set = xrealloc (yyvsp[-1].set, yyvsp[-1].n * sizeof(Confset));
	    yyvsp[-1].set[yyvsp[-1].n - 1] = yyvsp[0].set[0];
	    yyval = yyvsp[-1];
	;
    break;}
case 98:
#line 1031 "parser.y"
{
	    yyval = yyvsp[0];
	;
    break;}
case 99:
#line 1038 "parser.y"
{
	    yyval = yyvsp[0];
	;
    break;}
case 100:
#line 1044 "parser.y"
{
	    pmsg ("backend server [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 101:
#line 1049 "parser.y"
{
	    pmsg ("backend port [%d]\n", yyvsp[0].set[0].v.ival);
	    yyval = yyvsp[0];
	;
    break;}
case 102:
#line 1054 "parser.y"
{
	    pmsg ("backend verbosity [%d]\n", yyvsp[0].set[0].v.ival);
	    yyval = yyvsp[0];
	;
    break;}
case 103:
#line 1059 "parser.y"
{
	    pmsg ("backend onstart [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 104:
#line 1064 "parser.y"
{
	    pmsg ("backend onend [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 105:
#line 1069 "parser.y"
{
	    pmsg ("backend onfail [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 106:
#line 1074 "parser.y"
{
	    pmsg ("backend trafficlog [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 107:
#line 1079 "parser.y"
{
	    pmsg ("backend trafficlog [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 108:
#line 1084 "parser.y"
{
	    pmsg ("backend HTTP timing log [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 109:
#line 1089 "parser.y"
{
	    pmsg ("backend weight [%d]\n", yyvsp[0].set[0].v.ival);
	    yyval = yyvsp[0];
	;
    break;}
case 110:
#line 1094 "parser.y"
{
	    pmsg ("backend decay [%d]\n", yyvsp[0].set[0].v.ival);
	    yyval = yyvsp[0];
	;
    break;}
case 111:
#line 1099 "parser.y"
{
	    pmsg ("backend maxconnections [%d]\n", yyvsp[0].set[0].v.ival);
	    yyval = yyvsp[0];
	;
    break;}
case 112:
#line 1104 "parser.y"
{
	    pmsg ("backend sticky cookie [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 113:
#line 1109 "parser.y"
{
	    pmsg ("addclientheader [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 114:
#line 1114 "parser.y"
{
	    pmsg ("setclientheader [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 115:
#line 1119 "parser.y"
{
	    pmsg ("appendclientheader [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 116:
#line 1124 "parser.y"
{
	    pmsg ("addserverheader [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 117:
#line 1129 "parser.y"
{
	    pmsg ("setserverheader [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 118:
#line 1134 "parser.y"
{
	    pmsg ("appendserverheader [%s]\n", yyvsp[0].set[0].v.sval);
	    yyval = yyvsp[0];
	;
    break;}
case 119:
#line 1139 "parser.y"
{
	    pmsg ("backend retries [%d]\n", yyvsp[0].set[0].v.ival);
	    yyval = yyvsp[0];
	;
    break;}
case 120:
#line 1144 "parser.y"
{
	    pmsg ("backend state [%d]\n", yyvsp[0].set[0].v.ival);
	    yyval = yyvsp[0];
	;
    break;}
case 121:
#line 1154 "parser.y"
{
	    pmsg ("server statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof (Confset));
	    yyval.set[0].cf = cf_serverspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 122:
#line 1166 "parser.y"
{
	    pmsg ("weight statement [%d]\n", lastnr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof (Confset));
	    yyval.set[0].cf = cf_weightspec;
	    yyval.set[0].v.ival = lastnr;
	;
    break;}
case 123:
#line 1178 "parser.y"
{
	    pmsg ("decay statement [%d]\n", lastnr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof (Confset));
	    yyval.set[0].cf = cf_decayspec;
	    yyval.set[0].v.ival = lastnr;
	;
    break;}
case 124:
#line 1188 "parser.y"
{
	    setlaststr (laststring);
	;
    break;}
case 125:
#line 1196 "parser.y"
{
	    pmsg ("retries [%d]\n", lastnr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_retriesspec;
	    yyval.set[0].v.ival = lastnr;
	;
    break;}
case 126:
#line 1208 "parser.y"
{
	    pmsg ("state [%d]\n", lastnr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_statespec;
	    yyval.set[0].v.ival = lastnr;
	;
    break;}
case 128:
#line 1223 "parser.y"
{
	    lastnr = st_available;
	;
    break;}
case 129:
#line 1227 "parser.y"
{
	    lastnr = st_unavailable;
	;
    break;}
case 130:
#line 1231 "parser.y"
{
	    lastnr = st_down;
	;
    break;}
case 131:
#line 1239 "parser.y"
{
	    pmsg ("onstart statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof (Confset));
	    yyval.set[0].cf = cf_onstartspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 132:
#line 1251 "parser.y"
{
	    pmsg ("onfail statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof (Confset));
	    yyval.set[0].cf = cf_onfailspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 133:
#line 1263 "parser.y"
{
	    pmsg ("onend statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof (Confset));
	    yyval.set[0].cf = cf_onendspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 134:
#line 1275 "parser.y"
{
	    pmsg ("trafficlog statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof (Confset));
	    yyval.set[0].cf = cf_dumpspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 135:
#line 1287 "parser.y"
{
	    pmsg ("throughputlog statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof (Confset));
	    yyval.set[0].cf = cf_thruspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 136:
#line 1299 "parser.y"
{
	    pmsg ("httptiminglog statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof (Confset));
	    yyval.set[0].cf = cf_httptimingspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 137:
#line 1310 "parser.y"
{
	    setlaststr (laststring);
	    free (laststring);
	    laststring = 0;
	;
    break;}
case 138:
#line 1319 "parser.y"
{
	    setlaststr (laststring);
	    free (laststring);
	    laststring = 0;
	;
    break;}
case 139:
#line 1329 "parser.y"
{
	    pmsg ("insertcookie statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof (Confset));
	    yyval.set[0].cf = cf_stickycookiespec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 140:
#line 1340 "parser.y"
{
		setlaststr (laststring);
		free (laststring);
		laststring = 0;
	;
    break;}
case 141:
#line 1350 "parser.y"
{
	    pmsg ("addclientheader statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_addclientheaderspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 142:
#line 1362 "parser.y"
{
	    pmsg ("setclientheader statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_setclientheaderspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 143:
#line 1374 "parser.y"
{
	    pmsg ("appendclientheader statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_appendclientheaderspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 144:
#line 1386 "parser.y"
{
	    pmsg ("addserverheader statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_addserverheaderspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 145:
#line 1398 "parser.y"
{
	    pmsg ("setserverheader statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_setserverheaderspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 146:
#line 1410 "parser.y"
{
	    pmsg ("appendserverheader statement [%s]\n", laststr);
	    yyval.n = 1;
	    yyval.set = xmalloc (sizeof(Confset));
	    yyval.set[0].cf = cf_appendserverheaderspec;
	    yyval.set[0].v.sval = xstrdup (laststr);
	;
    break;}
case 147:
#line 1421 "parser.y"
{
	    setlaststr (laststring);
	    free (laststring);
	    laststring = 0;
	;
    break;}
case 148:
#line 1428 "parser.y"
{
    yyerrmsg = "HTTP header specifier expected";
;
    break;}
case 149:
#line 1433 "parser.y"
{
    yyerrmsg = "cookie specifier expected";
;
    break;}
case 150:
#line 1438 "parser.y"
{
    yyerrmsg = "number expected";
;
    break;}
case 151:
#line 1443 "parser.y"
{
    yyerrmsg = "hostname or IP address expected";
;
    break;}
case 152:
#line 1448 "parser.y"
{
    yyerrmsg = "'service' expected";
;
    break;}
case 153:
#line 1453 "parser.y"
{
    yyerrmsg = "backend definition statement expected";
;
    break;}
case 154:
#line 1458 "parser.y"
{
    yyerrmsg = "service body statement expected";
;
    break;}
case 155:
#line 1463 "parser.y"
{
    yyerrmsg = "semicolon (;) expected";
;
    break;}
case 156:
#line 1468 "parser.y"
{
    yyerrmsg = "'on' or 'off' expetcted";
;
    break;}
case 157:
#line 1473 "parser.y"
{
    yyerrmsg = "dispatch method expected";
;
    break;}
case 158:
#line 1478 "parser.y"
{
    yyerrmsg = "command line expected";
;
    break;}
case 159:
#line 1483 "parser.y"
{
    yyerrmsg = "file name expected";
;
    break;}
case 160:
#line 1488 "parser.y"
{
    yyerrmsg = "service name (identifier) expected";
;
    break;}
case 161:
#line 1493 "parser.y"
{
    yyerrmsg = "backend name (identifier) expected";
;
    break;}
case 162:
#line 1498 "parser.y"
{
    yyerrmsg = "IP address such as 1.2.3.4 or 'any' expected";
;
    break;}
case 163:
#line 1503 "parser.y"
{
    yyerrmsg = "Service type expected ('any', 'stickyhttp', ...)";
;
    break;}
case 164:
#line 1508 "parser.y"
{
    yyerrmsg = "Header inspection mode mode expected ('shallow' or 'deep')";
;
    break;}
case 165:
#line 1513 "parser.y"
{
    yyerrmsg = "IP filter(s) expected";
;
    break;}
case 166:
#line 1518 "parser.y"
{
    yyerrmsg = "username expected";
;
    break;}
case 167:
#line 1523 "parser.y"
{
    yyerrmsg = "state definition expected";
;
    break;}
case 170:
#line 1538 "parser.y"
{
    yyerrmsg = "'{' expected";
;
    break;}
case 171:
#line 1542 "parser.y"
{
    yyerrmsg = "'}' expected";
;
    break;}
case 172:
#line 1546 "parser.y"
{
    yyerrmsg = "option statement (logactivity, tcpbuffersize, ...) expected";
;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1549 "parser.y"
