/*************************************************************************
 * This file is part of Crosroads 1.76, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

void uid_assume() {
    uid_set = 0;
    gid_set = 0;
    
    if (activeservice->uid) {
	if (activeservice->gid) {
	    gid_org = getgid();
	    if (setegid (activeservice->gid))
		error ("Service %s: cannot set effective gid to %d: %s",
		       activeservice->name, activeservice->gid,
		       strerror(errno));
	    gid_set++;
	}
	uid_org = getuid();
	if (seteuid (activeservice->uid))
	    error ("Service %s: cannot set effective uid to %d: %s",
		   activeservice->name, activeservice->uid, strerror(errno));
	uid_set++;
    }
}
